import { render } from './render';
import { mount, unmount } from './mount';
/** render wrapper */
function _r(props) {
    return render(this, this.instance, props);
}
const inNode = typeof window === 'undefined';
/** wrapped mount */
function _wm(options) {
    /* istanbul ignore next */
    // eslint-disable-next-line @typescript-eslint/strict-boolean-expressions
    if (inNode)
        return null;
    // eslint-disable-next-line
    const target = options && options.target;
    if (target === null)
        return null;
    // eslint-disable-next-line
    const props = options && options.props;
    // eslint-disable-next-line
    const count = !((options && options.count) === false);
    const targetElement = mount(this.instance, this, target, props, count);
    return targetElement;
}
/** wrapped unmount */
function _wu(options) {
    /* istanbul ignore next */
    // eslint-disable-next-line @typescript-eslint/strict-boolean-expressions
    if (inNode)
        return;
    // eslint-disable-next-line
    const target = options && options.target;
    // eslint-disable-next-line
    const delay = (options && options.delay) || 0;
    // eslint-disable-next-line
    const count = !((options && options.count) === false);
    if (target === null)
        return;
    if (delay === 0)
        unmount(this.instance, this, target, count);
    else {
        setTimeout(() => unmount(this.instance, this, target, count), delay);
    }
}
/** create CNode */
const _cc = function (instance, $, props, children) {
    return {
        instance,
        $,
        props,
        children,
        els: [],
        render: _r,
        mount: _wm,
        unmount: _wu
    };
};
export const c = function (instance, $, props, children) {
    if (Array.isArray($)) {
        return _cc(instance, { $: null }, null, $);
    }
    if (Array.isArray(props)) {
        return _cc(instance, $, null, props);
    }
    else if (Array.isArray(children)) {
        return _cc(instance, $, props, children);
    }
    else {
        return _cc(instance, $, props, null);
    }
};
